#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\Blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "data.h"
#include <string.h>

#include "resource\BitMapFont.h"
//#include "resource\BGFont.h"

#include <stdlib.h>

#define TRUE  (1)
#define FALSE (0)

//const int __gba_multiboot;	//GBANp
//---------------------------------------------------------------------------
typedef struct {
	u8  Header;			//wb_̐擪
	u8  MachineCode;	//@R[h
	u8  MachineFlag;	//@ˑtO
	u8  ScreenMode;		//XN[[h
	u16 StartWdith;		//\Jnʒuw
	u16 StartHeight;	//\Jnʒux
	u16 EndWdith;		//\Iʒuw
	u16 EndHeight;		//\Iʒux	
	u32 FlagAOffset;	//tO`̃ItZbg
	u32 FlagBOffset;	//tOãItZbg
	u32 FlagBSize;		//tOãTCY
	u32 PixelOffset;	//sNZ̃ItZbg
	u32 PixelSize;		//sNZ̃TCY
}MAGHEADER_ST;

typedef struct {
	u8* Front;			//t@C̐擪ʒu
	u8* Header;			//wb_̈ʒu
	u8* Palette;		//pbg̈ʒu
}MAGEXTRACTION_ST;

MAGHEADER_ST       MAGHEADER;
MAGEXTRACTION_ST   MAGEXTRACTION;

u16 MagColor16[16];
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
u8   MAGChkID();
void MAGSetOffset();
void MAGSetHeader();
void MAGSetPalette();

u16  MAGGetPalette(u8);

void MAGDrawPicture();
void MAGDraw4Dot(u8, u8, u8*);
void MAGDraw4DotRelative(u8, u8, u8);

void MAGDebugStruct();
//---------------------------------------------------------------------------
int main(void)
{
	SetMode(MODE_3 | BG2_ENABLE);

	MAGSetOffset(_TEST_IMG_BIN_OFFSET);

	if(MAGChkID() == TRUE)
	{
		MAGSetHeader();
		MAGSetPalette();
		
		MAGDrawPicture();
	}

	for(;;){}
	return 0;
}
//---------------------------------------------------------------------------
void MAGSetOffset(u32 offset)
{
	MAGEXTRACTION.Front = EtfsOffset(offset);
}
//---------------------------------------------------------------------------
u8 MAGChkID()
{
	u8 IDString[8] = "MAKI02  ";
	u8 IDLength    = 8;

	if(strncmp(MAGEXTRACTION.Front, IDString, IDLength) != 0)
	{
		dprintf("MAGt@CȂ\n");
		return FALSE;
	}

	return TRUE;
}
//---------------------------------------------------------------------------
void MAGSetHeader()
{
	u8* MagOffset = MAGEXTRACTION.Front;

	//RgXLbv
	for(;;) if(*MagOffset++ == 0x1a) break;

	MAGEXTRACTION.Header  = MagOffset;
	MAGEXTRACTION.Palette = MagOffset + 32; //wb_32Byte

	MAGHEADER.Header      = *(MagOffset + 0);
	MAGHEADER.MachineCode = *(MagOffset + 1);
	MAGHEADER.MachineFlag = *(MagOffset + 2);
	MAGHEADER.ScreenMode  = *(MagOffset + 3);

	MAGHEADER.StartWdith  = *(MagOffset +  4) | *(MagOffset +  5)<<8;
	MAGHEADER.StartHeight = *(MagOffset +  6) | *(MagOffset +  7)<<8;
	MAGHEADER.EndWdith    = *(MagOffset +  8) | *(MagOffset +  9)<<8;
	MAGHEADER.EndHeight   = *(MagOffset + 10) | *(MagOffset + 11)<<8;

	MAGHEADER.FlagAOffset = *(MagOffset + 12)     | *(MagOffset + 13)<< 8 |
	                        *(MagOffset + 14)<<16 | *(MagOffset + 15)<<24;

	MAGHEADER.FlagBOffset = *(MagOffset + 16)     | *(MagOffset + 17)<< 8 |
	                        *(MagOffset + 18)<<16 | *(MagOffset + 19)<<24;

	MAGHEADER.FlagBSize   = *(MagOffset + 20)     | *(MagOffset + 21)<< 8 |
	                        *(MagOffset + 22)<<16 | *(MagOffset + 23)<<24;
	
	MAGHEADER.PixelOffset = *(MagOffset + 24)     | *(MagOffset + 25)<< 8 |
	                        *(MagOffset + 26)<<16 | *(MagOffset + 27)<<24;
	
	MAGHEADER.PixelSize   = *(MagOffset + 28)     | *(MagOffset + 29)<< 8 |
	                        *(MagOffset + 30)<<16 | *(MagOffset + 31)<<24;

	MAGDebugStruct();
}
//---------------------------------------------------------------------------
void MAGDebugStruct()
{
	dprintf("\n");
	dprintf("--- MAG EXTRACTION ---\n");
	
	dprintf("EXT Header =0x%x\n", MAGEXTRACTION.Header );
	dprintf("EXT Palette=0x%x\n", MAGEXTRACTION.Palette);

	dprintf("\n");
	dprintf("--- MAG HEADER ---\n");

	dprintf("Header     =0x%x\n", MAGHEADER.Header     );
	dprintf("MachineCode=0x%x\n", MAGHEADER.MachineCode);
	dprintf("MachineFlag=0x%x\n", MAGHEADER.MachineFlag);
	dprintf("ScreenMode =0x%x\n", MAGHEADER.ScreenMode );

	dprintf("StartWdith =0x%x\n", MAGHEADER.StartWdith );
	dprintf("StartHeight=0x%x\n", MAGHEADER.StartHeight);
	dprintf("EndWdith   =0x%x\n", MAGHEADER.EndWdith   );
	dprintf("EndHeight  =0x%x\n", MAGHEADER.EndHeight  );

	dprintf("FlagAOffset=0x%x\n", MAGHEADER.FlagAOffset);
	dprintf("FlagBOffset=0x%x\n", MAGHEADER.FlagBOffset);
	dprintf("FlagBSize  =0x%x\n", MAGHEADER.FlagBSize  );
	dprintf("PixelOffset=0x%x\n", MAGHEADER.PixelOffset);
	dprintf("PixelSize  =0x%x\n", MAGHEADER.PixelSize  );
	dprintf("------------------\n");
}
//---------------------------------------------------------------------------
void MAGSetPalette()
{
	u8* pCol = MAGEXTRACTION.Palette;
	u8  r,g,b;
	u8  i;

	for(i=0; i<16; i++)
	{
		g = *pCol++ / 8;	//0`255iK̂߁A8Ŋ܂
		r = *pCol++ / 8;
		b = *pCol++ / 8;
		MagColor16[i] = RGB(r,g,b);

		dprintf("Palette No.%d (%d,%d,%d) \n", i, r,g,b);
	}
}
//---------------------------------------------------------------------------
void MAGDrawPicture()
{
	u8  midFlag;
	u8  BitMask = 0x80;
	u8  FlagTable[80];

	u8* pFlagA  = MAGEXTRACTION.Header + MAGHEADER.FlagAOffset;
	u8* pFlagB  = MAGEXTRACTION.Header + MAGHEADER.FlagBOffset;
	u8* pPixel  = MAGEXTRACTION.Header + MAGHEADER.PixelOffset;

	dprintf("pFlagA = 0x%x \n", pFlagA);
	dprintf("pFlagB = 0x%x \n", pFlagB);
	dprintf("pPixel = 0x%x \n", pPixel);

	//tOe[ȕ
	u16 i;
	for(i=0; i<80; i++)
	{
		FlagTable[i] = 0;
	}

	//WJJnI
	u16 x,y;
	for(y=0; y<160; y++)
	{
		for(x=0; x<640/8; x++)		//x4hbgPʂł
		{
			if( *pFlagA & BitMask ) midFlag = *pFlagB++;
			else                    midFlag = 0x00;

			FlagTable[x]  = midFlag ^ FlagTable[x];

			if((BitMask >>= 1) == 0x00)
			{
				BitMask = 0x80;
				pFlagA++;
			}

			//GBẢʃTCYl
			if(x>SCREEN_CX/8) continue;

			if(FlagTable[x] == 0x00)
			{
				MAGDraw4Dot(x*8+0, y, pPixel); pPixel+=2;
				MAGDraw4Dot(x*8+4, y, pPixel); pPixel+=2;
				continue;
			}

			if(FlagTable[x] & 0xf0)
			{
				MAGDraw4DotRelative(x*8+0, y, FlagTable[x] >> 4);
			}
			else
			{
				MAGDraw4Dot(x*8+0, y, pPixel);
				pPixel+=2;
			}
			if(FlagTable[x] & 0x0f)
			{
				MAGDraw4DotRelative(x*8+4, y, FlagTable[x] & 0x0f);
			}
			else
			{
				MAGDraw4Dot(x*8+4, y, pPixel);
				pPixel+=2;
			}
		}// for x
	}// for y
}
//---------------------------------------------------------------------------
void MAGDraw4DotRelative(u8 x, u8 y, u8 flagNum)
{
	u8 Xtable[16] = {0, 1, 2, 4, 0, 1, 0, 1, 2, 0, 1, 2, 0, 1, 2,  0};
	u8 Ytable[16] = {0, 0, 0, 0, 1, 1, 2, 2, 2, 4, 4, 4, 8, 8, 8, 16};

	//΍W̌vZ
	u8 x2 = x - (Xtable[flagNum] * 4);
	u8 y2 = y - (Ytable[flagNum]    );

	Mode3DrawDot(x++, y, Mode3GetDotRGB(x2++,y2) );
	Mode3DrawDot(x++, y, Mode3GetDotRGB(x2++,y2) );
	Mode3DrawDot(x++, y, Mode3GetDotRGB(x2++,y2) );
	Mode3DrawDot(x++, y, Mode3GetDotRGB(x2++,y2) );
}
//---------------------------------------------------------------------------
//x4hbgPʂł
void MAGDraw4Dot(u8 x, u8 y, u8* pPixel)
{
	if(x+3   >= 239) return;
	if(y     >= 159) return;

	u16 col0 = MAGGetPalette( (*(pPixel+0) & 0xf0) >> 4 );
	u16 col1 = MAGGetPalette( (*(pPixel+0) & 0x0f)      );
	u16 col2 = MAGGetPalette( (*(pPixel+1) & 0xf0) >> 4 );
	u16 col3 = MAGGetPalette( (*(pPixel+1) & 0x0f)      );

	Mode3DrawDot(x+0, y, col0);
	Mode3DrawDot(x+1, y, col1);
	Mode3DrawDot(x+2, y, col2);
	Mode3DrawDot(x+3, y, col3);
}
//---------------------------------------------------------------------------
u16  MAGGetPalette(u8 col)
{
	return MagColor16[col];
}
//---------------------------------------------------------------------------
